//             (C) by Florian Lindner 1998
//---------------------------------------------------------------------------
#ifndef FVolumeControlH
#define FVolumeControlH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
#include <vcl\extctrls.hpp>
//---------------------------------------------------------------------------
class FVolumeControl : public TGraphicControl
{
private:
// ------------- FSlider BEGIN -------------------------------------------------
	class FSlider : public TCustomControl
    {
    friend class FVolumeControl;
    private:
// ------------- FMover BEGIN --------------------------------------------------
		class FMover : public TGraphicControl
        {
        private:
        	TPoint p[10];
            TPoint p1[5];
            TPoint p2[5];
        protected:
        	void __fastcall Paint();
        public:
        	__fastcall FMover(TComponent *Owner);
        __published:
        };
// ------------- FMover END ----------------------------------------------------
    	int FPosition;
        int DeviceID;
        void __fastcall SetPosition(int);
        void inline __fastcall SetVolume(int);
        FMover *Mover;
        TRect rect;
        bool MouseD;
    protected:
    	void __fastcall Paint();
        void __fastcall MouseDown(TMouseButton,TShiftState,int,int);
        void __fastcall MouseUp(TMouseButton,TShiftState,int,int);
        void __fastcall MouseMove(TShiftState,int,int);
	    void __fastcall CMMouseEnter(TMessage *);
	    void __fastcall CMMouseLeave(TMessage *);
    public:
    	__fastcall FSlider(TComponent *Owner);
    __published:
    	__property int Position = { read = FPosition, write = SetPosition, default = 0 };
    BEGIN_MESSAGE_MAP
        MESSAGE_HANDLER(CM_MOUSEENTER, TMessage *, CMMouseEnter);
        MESSAGE_HANDLER(CM_MOUSELEAVE, TMessage *, CMMouseLeave);
   	END_MESSAGE_MAP(TCustomControl);
    };
// ------------- FSlider END ---------------------------------------------------
// ------------- FHorzLabel BEGIN ----------------------------------------------
	class FHorzLabel : public TGraphicControl
    {
    private:
    	AnsiString FCaption;
        void __fastcall SetCaption(AnsiString);
        AnsiString __fastcall GetCharAtPos(int,AnsiString);
    protected:
    	void __fastcall Paint();
	    void __fastcall CMMouseEnter(TMessage *);
	    void __fastcall CMMouseLeave(TMessage *);
    public:
    	__fastcall FHorzLabel(TComponent *Owner);
    __published:
    	__property AnsiString Caption = { read = FCaption, write = SetCaption, nodefault };
        __property Hint;
        __property ShowHint;
    BEGIN_MESSAGE_MAP
        MESSAGE_HANDLER(CM_MOUSEENTER, TMessage *, CMMouseEnter);
	    MESSAGE_HANDLER(CM_MOUSELEAVE, TMessage *, CMMouseLeave);
	END_MESSAGE_MAP(TGraphicControl);
	};
// ------------- FHorzLabel END ------------------------------------------------
// ------------- FCustomButton BEGIN -------------------------------------------
	class FCustomButton : public TCustomControl
    {
    private:
    	bool MouseOver;
        bool MouseD;
        TRect rect;
    protected:
	    void __fastcall Paint();
	    void __fastcall MouseDown(TMouseButton,TShiftState,int,int);
	    void __fastcall MouseUp(TMouseButton,TShiftState,int,int);
	    void __fastcall CMMouseEnter(TMessage *);
	    void __fastcall CMMouseLeave(TMessage *);
    public:
        __fastcall FCustomButton(TComponent *Owner);
        void __fastcall SetBounds(int,int,int,int);
    __published:
       	__property OnClick;
    BEGIN_MESSAGE_MAP
        MESSAGE_HANDLER(CM_MOUSEENTER, TMessage *, CMMouseEnter);
	    MESSAGE_HANDLER(CM_MOUSELEAVE, TMessage *, CMMouseLeave);
	END_MESSAGE_MAP(TCustomControl);
    };
// ------------- FCustomButton END ---------------------------------------------
// ------------- FShadowLabel BEGIN --------------------------------------------
	class FShadowLabel : public TGraphicControl
    {
    private:
    	AnsiString FCaption;
        void __fastcall SetCaption(AnsiString);
        bool MouseOver;
    protected:
    	void __fastcall Paint();
        void __fastcall CMMouseEnter(TMessage *);
	    void __fastcall CMMouseLeave(TMessage *);
    public:
    	__fastcall FShadowLabel(TComponent *Owner);
        void __fastcall SetBounds(int,int,int,int);
    __published:
    	__property AnsiString Caption = { read = FCaption, write = SetCaption, nodefault };
    BEGIN_MESSAGE_MAP
        MESSAGE_HANDLER(CM_MOUSEENTER, TMessage *, CMMouseEnter);
	    MESSAGE_HANDLER(CM_MOUSELEAVE, TMessage *, CMMouseLeave);
	END_MESSAGE_MAP(TGraphicControl);
    };
// ------------- FShadowLabel END ----------------------------------------------
    bool MouseOver;
    int Volumes[16];
    TRect r1;
    TRect r2;
    TRect r3;
    AnsiString FCaption;
    AnsiString DeviceNames[16];
    AnsiString __fastcall GetCharAtPos(int,AnsiString);
    TPoint FormPos;
    void __fastcall SetCaption(AnsiString);
    void __fastcall OnLooseFocus(TObject *);
    void __fastcall OnBtCloseClick(TObject *);
    void __fastcall OnLayerFormPaint(TObject *);
    void __fastcall GetDeviceInfos();
    void __fastcall GetVolumeInfos();
    TForm *LayerForm;
    FSlider *__fastcall CreateSlider();
    FSlider *Slider01;
    FSlider *Slider02;
    FSlider *Slider03;
    FSlider *Slider04;
    FSlider *Slider05;
    FSlider *Slider06;
    FSlider *Slider07;
    FSlider *Slider08;
    FSlider *Slider09;
    FSlider *Slider10;
    FSlider *Slider11;
    FSlider *Slider12;
    FSlider *Slider13;
    FSlider *Slider14;
    FSlider *Slider15;
    FSlider *Slider16;
    FHorzLabel *__fastcall CreateHorzLabel();
    FHorzLabel *Label01;
    FHorzLabel *Label02;
    FHorzLabel *Label03;
    FHorzLabel *Label04;
    FHorzLabel *Label05;
    FHorzLabel *Label06;
    FHorzLabel *Label07;
    FHorzLabel *Label08;
    FHorzLabel *Label09;
    FHorzLabel *Label10;
    FHorzLabel *Label11;
    FHorzLabel *Label12;
    FHorzLabel *Label13;
    FHorzLabel *Label14;
    FHorzLabel *Label15;
    FHorzLabel *Label16;
    FCustomButton *BtClose;
    FShadowLabel *CaptionLabel;
    int NumberOfDevices;
protected:
	void __fastcall Paint();
    void __fastcall CMMouseEnter(TMessage *);
    void __fastcall CMMouseLeave(TMessage *);
    void __fastcall MouseDown(TMouseButton,TShiftState,int,int);
public:
	__fastcall FVolumeControl(TComponent* Owner);
    void __fastcall SetBounds(int,int,int,int);
__published:
	__property AnsiString Caption = { read = FCaption, write = SetCaption, nodefault };
BEGIN_MESSAGE_MAP
    MESSAGE_HANDLER(CM_MOUSEENTER, TMessage *, CMMouseEnter);
    MESSAGE_HANDLER(CM_MOUSELEAVE, TMessage *, CMMouseLeave);
END_MESSAGE_MAP(TGraphicControl);
};
//---------------------------------------------------------------------------
#endif
